<template>
  <div class='container'>
    <div v-show='!successful'>
      <div class='app-form'>
        <h2 id='franchise-title'> Franchise Application</h2>
        <form ref='formFranchise'>
          <div class='app-form__wrap'>
            <p class='app-form__title app-form__title--first'>TBCC DEALER PACKAGE SELECTION</p>
            <div class='app-form__section app-form__section--first'>
              <tbcc-dropdown :id="'package'" v-model='currentPackage' :invalid='packageInvalid' name='plan' class='width50 mr20 dropdown-package' :id-dropdown="'dropdown1'" :list="listPackage" item-key="name" placeholder='TBCC PACKAGE' label="Package" filter-off  @selected="(value) => selectedPackage(value)"/>
              <div class='app-form__description width50 ml20'>
                <p class='app-form__description-item'>Please select the dealership package you want.</p>
                <p class='app-form__description-item'>The most suitable package for your business will be determined by mutual negotiation.</p>
                <p class='app-form__description-item app-form__description-item--active' >No fee / payment will be taken at the application stage.</p>
              </div>
            </div>
            <p class='app-form__title'>Application TYPE</p>
            <div class='app-form__section'>
              <tbcc-radio-button v-model='appType' name='application-type' class='width50 mb25' label='Legal (I have a company)'  value='legal' />
              <tbcc-radio-button v-model='appType' name='application-type' class='width50' label='Individual (I will establish a company)'  value='individual'/>
            </div>
            <p class='app-form__title'>YOUR CONTACTS</p>
            <div class='app-form__section'>
              <base-input-black v-model='name' name='name' class='width50 mr20 mb20 ' :label='"Your Name *"' placeholder='Your Name *'  :invalid='nameInvalid' required-field @input='nameInvalid = false' />
              <base-input-black v-model='surname' name='surname' class='width50 ml20 mb20 ' :label='"Your Surname *"' placeholder='Your Surname *'  :invalid='surnameInvalid' required-field @input='surnameInvalid = false' />
              <base-input-black v-model='email' name='email' class='width50 mr20 mb20' :label='"Email *"' placeholder='Email *' type="email" :invalid='emailInvalid' required-field @input='emailInvalid = false' />
              <base-input-black v-model='number' name='number' class='width50 ml20 mb20' :label='"Your phone number *"' placeholder='Your phone number *' :invalid='numberInvalid' type="tel"  required-field @input='numberInvalid = false' />
              <base-input-black v-model='company' name='company' class='width50 mr20 mb20 ' :label='"Company"' placeholder='Company'  />
            </div>
            <p class='app-form__title'>THE LOCATION YOU REQUEST DEALERSHIP</p>
            <div class='app-form__section'>
              <tbcc-dropdown v-if='currentPackage === "TBCC OTC / E-Box" || currentPackage === "TBCC OTC / Store"' :id="'country'" v-model='country' name='country' class='width50 mr20 mb20 ' :id-dropdown="'dropdown2'" :list="listCountry" item-key="name" placeholder='Select country' label="Select country" @selected="(value) => country = value.name" />
              <base-input-black v-else v-model='country' name='country' class='width50 mr20 mb20 ' :label='"Select country"' placeholder='Select country' />
              <tbcc-dropdown :id="'city'" v-model='city' name='city' class='width50 ml20 mb20 ' :id-dropdown="'dropdown3'" :list="listCity" item-key="name" placeholder='Select city' label="Select city" :readonly='currentPackage !== "TBCC OTC / E-Box" && currentPackage !== "TBCC OTC / Store"' @selected="(value) => city = value.name" />
              <base-input-black v-model='district' name='district' class='width50 mr20 mmb20' :label='"District"' placeholder='District' :readonly='currentPackage !== "TBCC OTC / E-Box" && currentPackage !== "TBCC OTC / Store"' />
              <base-input-black v-model='address' name='address' class='width50 ml20' :label='"Address"' placeholder='Address' :readonly='currentPackage !== "TBCC OTC / E-Box" && currentPackage !== "TBCC OTC / Store"' />
            </div>
            <p class='app-form__title'>APPROVALS AND PERMISSIONS</p>
            <div class='app-form__section app-form__section--last'>
              <tbcc-checkbox v-model='checkboxContact' class='mb20' label='I want to be a TBCC Hub. You can contact me regarding this matter.' />
              <tbcc-checkbox v-model='checkboxServices' label='I will not buy/sell goods and services with crypto money on the TBCC Hub.' />
            </div>
            <base-button shaded class='app-form__button' type='submit' @click.native.prevent='send'>
              Complete Application
            </base-button>
          </div>
        </form>
      </div>
    </div>
    <div v-show='successful' class='successful-text'>
      <h2 class='base-title'>Application sent</h2>
    </div>
  </div>
</template>

<script>
import emailjs from '@emailjs/browser'
import { mapActions, mapGetters } from 'vuex'
import BaseInputBlack from '../base/BaseInputBlack'
import BaseButton from '../base/BaseButton'
import TbccRadioButton from './TbccRadioButton'
import TbccCheckbox from './TbccCheckbox'
import TbccDropdown from './TbccDropdown'
export default {
  components: { BaseButton, BaseInputBlack, TbccDropdown, TbccCheckbox, TbccRadioButton },
  data() {
    return {
      appType: 'legal',
      listPackage: [
        {
          name: 'TBCC Cloud / START',
        },
        {
          name: 'TBCC Cloud / CLOUD X',
        },
        {
          name: 'TBCC Cloud / PREMIUM',
        },
        {
          name: 'TBCC / Individual',
        },
      ],
      listCountry: [
        {
          name: 'Turkey'
        }
      ],
      listCity: [
        {
          name: 'İstanbul'
        },
        {
          name: 'Ankara'
        },
        {
          name: 'İzmir'
        },
        {
          name: 'Adana'
        },
        {
          name: 'Adıyaman'
        },
        {
          name: 'Afyonkarahisar'
        },
        {
          name: 'Ağrı'
        },
        {
          name: 'Aksaray'
        },
        {
          name: 'Amasya'
        },
        {
          name: 'Antalya'
        },
        {
          name: 'Ardahan'
        },
        {
          name: 'Artvin'
        },
        {
          name: 'Aydın'
        },
        {
          name: 'Balıkesir'
        },
        {
          name: 'Bartın'
        },
        {
          name: 'Batman'
        },
        {
          name: 'Bayburt'
        },
        {
          name: 'Bilecik'
        },
        {
          name: 'Bingöl'
        },
        {
          name: 'Bitlis'
        },
        {
          name: 'Bolu'
        },
        {
          name: 'Burdur'
        },
        {
          name: 'Bursa'
        },
        {
          name: 'Çanakkale'
        },
        {
          name: 'Çankırı'
        },
        {
          name: 'Çorum'
        },
        {
          name: 'Denizli'
        },
        {
          name: 'Diyarbakır'
        },
        {
          name: 'Düzce'
        },
        {
          name: 'Edirne'
        },
        {
          name: 'Elazığ'
        },
        {
          name: 'Erzincan'
        },
        {
          name: 'Erzurum'
        },
        {
          name: 'Eskişehir'
        },
        {
          name: 'Gaziantep'
        },
        {
          name: 'Giresun'
        },
        {
          name: 'Gümüşhane'
        },
        {
          name: 'Hakkâri'
        },
        {
          name: 'Hatay'
        },
        {
          name: 'Iğdır'
        },
        {
          name: 'Isparta'
        },
        {
          name: 'Kahramanmaraş'
        },
        {
          name: 'Karabük'
        },
        {
          name: 'Karaman'
        },
        {
          name: 'Kars'
        },
        {
          name: 'Kastamonu'
        },
        {
          name: 'Kayseri'
        },
        {
          name: 'Kırıkkale'
        },
        {
          name: 'Kırklareli'
        },
        {
          name: 'Kırşehir'
        },
        {
          name: 'Kilis'
        },
        {
          name: 'Kocaeli'
        },
        {
          name: 'Konya'
        },
        {
          name: 'Kütahya'
        },
        {
          name: 'Malatya'
        },
        {
          name: 'Manisa'
        },
        {
          name: 'Mardin'
        },
        {
          name: 'Mersin'
        },
        {
          name: 'Muğla'
        },
        {
          name: 'Muş'
        },
        {
          name: 'Nevşehir'
        },
        {
          name: 'Niğde'
        },
        {
          name: 'Ordu'
        },
        {
          name: 'Osmaniye'
        },
        {
          name: 'Rize'
        },
        {
          name: 'Sakarya'
        },
        {
          name: 'Samsun'
        },
        {
          name: 'Siirt'
        },
        {
          name: 'Sinop'
        },
        {
          name: 'Sivas'
        },
        {
          name: 'Şırnak'
        },
        {
          name: 'Tekirdağ'
        },
        {
          name: 'Tokat'
        },
        {
          name: 'Trabzon'
        },
        {
          name: 'Tunceli'
        },
        {
          name: 'Şanlıurfa'
        },
        {
          name: 'Uşak'
        },
        {
          name: 'Van'
        },
        {
          name: 'Yalova'
        },
        {
          name: 'Yozgat'
        },
        {
          name: 'Zonguldak'
        },
      ],
      currentPackage: '',
      packageInvalid: false,
      name: '',
      nameInvalid: false,
      surname: '',
      surnameInvalid: false,
      email: '',
      emailInvalid: false,
      number: '',
      numberInvalid: false,
      company: '',
      country: '',
      city: '',
      district: '',
      address: '',
      checkboxContact: true,
      checkboxServices: false,
      successful: false
    }


  },

  computed: {
    ...mapGetters({
      getCurrentPlan: 'getCurrentPlan'
    })
  },

  mounted() {
    this.currentPackage = this.getCurrentPlan
  },

  methods: {
    ...mapActions({
      setCurrentPlan: 'setCurrentPlan'
    }),

    selectedPackage(value) {
      this.currentPackage = value.name
      this.packageInvalid = false
      this.setCurrentPlan(value.name)
    },

    async send() {
      let valid = true;
      if(this.name.length === 0) {
        this.nameInvalid = true
        valid = false
      }
      if(this.surname.length === 0) {
        this.surnameInvalid = true
        valid = false
      }
      if(this.currentPackage.length === 0) {
        this.packageInvalid = true
        valid = false
      }
      if(this.email.length === 0) {
        this.emailInvalid = true
        valid = false
      }
      if(this.number.length === 0) {
        this.numberInvalid = true
        valid = false
      }
      if(!valid){
        const el = document.getElementById('franchise-title');
        el.scrollIntoView();
      }
      if(valid) {
        await emailjs.sendForm('service_3v116fc', 'template_hkwsqem',  this.$refs.formFranchise, 'XzophZNPxXf0oQgPq')
          .then((result) => {
            console.log('SUCCESS!', result.text);
          }, (error) => {
            console.log('FAILED...', error.text);
          });
        this.successful = true
      }
    }
  }
}
</script>


<style lang='scss' scoped>
.container {
  display: flex;
  justify-content: center;
}

.app-form {
  max-width: 920px;
  width: 100%;
  background: #0E1B4E;
  border-radius: 36px;
  position: relative;
  padding: 48px;
  display: flex;
  align-items: center;
  flex-direction: column;

  @media (max-width: 767px) {
    max-width: 350px;
    padding: 48px 20px;
  }

  &__wrap {
    width: 100%;
  }

  &__title {
    font-weight: 600;
    font-size: 20px;
    text-transform: uppercase;
    color: white;
    display: inline-block;
    padding-bottom: 24px;
    width: 100%;
    margin: 0 0 40px;
    position: relative;
    z-index: 1;

    @media(max-width: 767px) {
      font-size: 16px;
      line-height: 16px;
      margin: 0 0 25px;
    }

    &::before {
      content: "";
      position: absolute;
      bottom: 0;
      left: 0;
      right: 0;
      background: linear-gradient(77.9deg, #0066FF -3.83%, #2CE0C5 110.36%);
      z-index: -1;
      margin-bottom: -2px;
      width: 100%;
      height: 2px;
    }

    &--first {
      margin-bottom: 20px;
    }
  }

  &__description {
    padding: 20px 0;
  }

  &__description-item {
      padding-left: 14px;
      margin: 4px 0px;
      font-size: 14px;
      line-height: 22px;
      color: rgba(255, 255, 255, 0.45);
      position: relative;

    @media(max-width: 767px) {
      font-size: 13px;
      line-height: 22px;
    }

      &::before {
        content: '';
        position: absolute;
        top: 50%;
        left: 0;
        transform: translateY(-50%);
        border-radius: 50%;
        width: 4px;
        height: 4px;
        background-color: rgba(255, 255, 255, 0.45);
      }

    &--active {
      color: white;
    }
  }

  &__section {
    display: flex;
    align-items: center;
    margin-bottom: 55px;
    flex-wrap: wrap;


    @media(max-width: 767px) {
      margin-bottom: 35px;
    }

    &--first {
      margin-bottom: 40px;
    }

    &--last {
      margin-bottom: 50px;

      @media(max-width: 767px) {
        margin-bottom: 30px;
      }
    }
  }

  &__button {
    margin-bottom: 13px;
    background: url("../../assets/img/white-vector.svg") no-repeat right 22px center ,linear-gradient(77.9deg, #0066FF -3.83%, #2CE0C5 110.36%);
    padding: 20px 60px 20px 40px;

    @media(max-width: 767px) {
      width: 100%;
      justify-content: center;
    }

    &:hover {
      background: url("../../assets/img/white-vector.svg") no-repeat right 22px center, linear-gradient(77.9deg,#06f -3.83%,#2ce0c5 72.3%);
    }
  }

  h2 {
    font-weight: 700;
    font-size: 36px;
    color: #FFFFFF;
    margin: 0 0 68px;

    @media (max-width: 767px) {
      font-size: 30px;
      line-height: 37px;
      text-align: center;
      max-width: 250px;
    }
  }

  @media (min-width: 768px) {
    &::before {
      content: "";
      position: absolute;
      width: 601px;
      height: 459px;
      top: -100px;
      left: -135px;
      background-image: url("../../assets/img/hub/bg-start-advantage.svg");
      background-repeat: no-repeat;
      background-position: center;
      pointer-events: none;
      z-index: -1;
    }
  }
}

.width100 {
  width: 100%;
}

.width50 {
  width: calc(50% - 20px);

  @media(max-width: 767px) {
    width: 100%;
  }
}

.mr20 {
  @media(min-width: 768px) {
    margin-right: 20px;
  }
}

.ml20 {
  @media(min-width: 768px) {
    margin-left: 20px;
  }
}

.mb20 {
  margin-bottom: 20px;
}

.mmb20 {
  @media(max-width: 767px) {
    margin-bottom: 20px;
  }
}

.mb25 {
  @media(max-width: 767px) {
    margin-bottom: 25px;
  }
}

.successful-text {
  min-height: 400px;
  display: flex;
  align-items: center;
  justify-content: center;

  h2 {
    font-size: 60px;
    font-weight: bold;
  }
}
</style>

<style lang='scss'>
.dropdown-package {
  background: linear-gradient(77.9deg, #0066FF -3.83%, #2CE0C5 110.36%);
  border-radius: 10px;

  label {
    display: none;
  }

  .base-input-wrapper {
    border: none !important;
    padding: 18px 17px 18px !important;
  }

}
</style>
